Index: /branches/multichoice/gui/scripts/vtkimageviewer.tcl
===================================================================
--- /branches/multichoice/gui/scripts/vtkimageviewer.tcl	(revision 6370)
+++ /branches/multichoice/gui/scripts/vtkimageviewer.tcl	(revision 6371)
@@ -70,5 +70,4 @@
     private method BuildImageTab {}
     private method BuildDownloadPopup { widget command }
-    private method Combo { option }
     private method Connect {}
     private method CurrentDatasets {args}
@@ -86,4 +85,5 @@
     private method IsValidObject { dataobj }
     private method LeaveLegend {}
+    private method LegendTitleAction { option }
     private method MotionLegend { x y }
     private method Pan {option x y}
@@ -100,4 +100,5 @@
     private method Rotate {option x y}
     private method SetCurrentColormap { color }
+    private method SetCurrentFieldName { dataobj }
     private method SetLegendTip { x y }
     private method SetObjectStyle { dataobj comp }
@@ -209,8 +210,8 @@
 
     array set _settings {
-        -axisflymode            "static"
+        -axesvisible            1
         -axislabels             1
         -axisminorticks         1
-        -axisvisible            1
+        -axismode               "static"
         -backingcolor           white
         -backingvisible         1
@@ -243,7 +244,5 @@
 
     itk_component add fieldmenu {
-        menu $itk_component(plotarea).menu \
-            -relief flat \
-            -tearoff 0
+        menu $itk_component(plotarea).menu -relief flat -tearoff 0
     } {
         usual
@@ -274,5 +273,6 @@
     }
     pack $itk_component(reset) -side top -padx 2 -pady { 2 0 }
-    Rappture::Tooltip::for $itk_component(reset) "Reset the view to the default zoom level"
+    Rappture::Tooltip::for $itk_component(reset) \
+        "Reset the view to the default zoom level"
 
     itk_component add zoomin {
@@ -473,7 +473,4 @@
     }
     array set params $settings
-    set params(-description) ""
-    set params(-param) ""
-    array set params $settings
 
     if {$params(-color) == "auto" || $params(-color) == "autoreset"} {
@@ -513,5 +510,4 @@
         set _dlist [lreplace $_dlist $pos $pos]
         array unset _obj2ovride $dataobj-*
-        array unset _settings $dataobj-*
         set changed 1
     }
@@ -573,5 +569,5 @@
             return $dlist
         }
-        -image {
+        "-image" {
             if {[llength $args] != 2} {
                 error "wrong # args: should be \"get -image view\""
@@ -587,5 +583,5 @@
         }
         default {
-            error "bad option \"$op\": should be -objects or -image"
+            error "bad option \"$op\": should be -objects, -visible or -image"
         }
     }
@@ -607,4 +603,6 @@
         }
         foreach axis { x y } {
+            set units [$dataobj hints ${axis}units]
+            set found($units) 1
             set lim [$dataobj limits $axis]
             if { ![info exists _limits($axis)] } {
@@ -621,6 +619,4 @@
             }
             set _limits($axis) [list $amin $amax]
-            set units [$dataobj hints ${axis}units]
-            set found($units) 1
         }
         foreach { fname lim } [$dataobj fieldlimits] {
@@ -903,5 +899,5 @@
         DoResize
         if { $_settings(-stretchtofit) } {
-            AdjustSetting -stretchToFit
+            AdjustSetting -stretchtofit
         }
     }
@@ -910,6 +906,9 @@
         # Reset the camera and other view parameters
         #
-        InitSettings -view3d -background
-
+        InitSettings -view3d -background \
+            -xgrid -ygrid -zgrid -axismode \
+            -axesvisible -axislabels -axisminorticks
+
+        SendCmd "axis tickpos outside"
         SendCmd "axis lrot z 90"
         $_arcball quaternion [ViewToQuaternion]
@@ -930,9 +929,10 @@
 
     set _first ""
-    # Start off with no datasets are visible.
+    # Start off with no datasets visible.
     SendCmd "dataset visible 0"
     foreach dataobj [get -objects] {
         if { [info exists _obj2ovride($dataobj-raise)] &&  $_first == "" } {
             set _first $dataobj
+            SetCurrentFieldName $dataobj
         }
         foreach comp [$dataobj components] {
@@ -971,39 +971,7 @@
         }
     }
-    if { $_first != ""  } {
-        $itk_component(field) choices delete 0 end
-        $itk_component(fieldmenu) delete 0 end
-        array unset _fields
-        set _curFldName ""
-        foreach cname [$_first components] {
-            foreach fname [$_first fieldnames $cname] {
-                if { [info exists _fields($fname)] } {
-                    continue
-                }
-                foreach { label units components } \
-                    [$_first fieldinfo $fname] break
-                $itk_component(field) choices insert end "$fname" "$label"
-                $itk_component(fieldmenu) add radiobutton -label "$label" \
-                    -value $label -variable [itcl::scope _curFldLabel] \
-                    -selectcolor red \
-                    -activebackground $itk_option(-plotbackground) \
-                    -activeforeground $itk_option(-plotforeground) \
-                    -font "Arial 8" \
-                    -command [itcl::code $this Combo invoke]
-                set _fields($fname) [list $label $units $components]
-                if { $_curFldName == "" } {
-                    set _curFldName $fname
-                    set _curFldLabel $label
-                }
-            }
-        }
-        $itk_component(field) value $_curFldLabel
-    }
+
     InitSettings -stretchtofit -outline
-
     if { $_reset } {
-        SendCmd "axis tickpos outside"
-        #SendCmd "axis lformat all %g"
-
         foreach axis { x y z } {
             set label ""
@@ -1046,6 +1014,5 @@
         }
         PanCamera
-        InitSettings -xgrid -ygrid -zgrid \
-            -axisvisible -axislabels -field -view3d
+        InitSettings -field -view3d
         if { [array size _fields] < 2 } {
             catch {blt::table forget $itk_component(field) $itk_component(field_l)}
@@ -1278,8 +1245,4 @@
 itcl::body Rappture::VtkImageViewer::InitSettings { args } {
     foreach spec $args {
-        if { [info exists _settings($_first${spec})] } {
-            # Reset global setting with dataobj specific setting
-            set _settings($spec) $_settings($_first${spec})
-        }
         AdjustSetting $spec
     }
@@ -1298,9 +1261,7 @@
     }
     switch -- $what {
-        "-axisflymode" {
-            set mode [$itk_component(axisflymode) value]
-            set mode [$itk_component(axisflymode) translate $mode]
-            set _settings($what) $mode
-            SendCmd "axis flymode $mode"
+        "-axesvisible" {
+            set bool $_settings($what)
+            SendCmd "axis visible all $bool"
         }
         "-axislabels" {
@@ -1312,7 +1273,9 @@
             SendCmd "axis minticks all $bool"
         }
-        "-axisvisible" {
-            set bool $_settings($what)
-            SendCmd "axis visible all $bool"
+        "-axismode" {
+            set mode [$itk_component(axismode) value]
+            set mode [$itk_component(axismode) translate $mode]
+            set _settings($what) $mode
+            SendCmd "axis flymode $mode"
         }
         "-background" {
@@ -1396,4 +1359,40 @@
             SendCmd "camera reset"
             DrawLegend
+        }
+        "-legendvisible" {
+            if { !$_settings($what) } {
+                $itk_component(view) delete legend
+            }
+            DrawLegend
+        }
+        "-level" {
+            set val $_settings($what)
+            SendCmd "image level $val"
+        }
+        "-opacity" {
+            set _changed($what) 1
+            if { $_settings(-view3d) } {
+                set _settings(-saveopacity) $_settings($what)
+                set val [expr $_settings($what) * 0.01]
+                SendCmd "image opacity $val"
+            } else {
+                SendCmd "image opacity 1.0"
+            }
+        }
+        "-outline" {
+            set bool $_settings($what)
+            SendCmd "outline visible $bool"
+        }
+        "-stretchtofit" {
+            set bool $_settings($what)
+            if { $bool } {
+                if { $_settings(-view3d) } {
+                    SendCmd "camera aspect native"
+                } else {
+                    SendCmd "camera aspect window"
+                }
+            } else {
+                SendCmd "camera aspect native"
+            }
         }
         "-view3d" {
@@ -1451,40 +1450,4 @@
             set val $_settings($what)
             SendCmd "image window $val"
-        }
-        "-level" {
-            set val $_settings($what)
-            SendCmd "image level $val"
-        }
-        "-legendvisible" {
-            if { !$_settings($what) } {
-                $itk_component(view) delete legend
-            }
-            DrawLegend
-        }
-        "-opacity" {
-            set _changed($what) 1
-            if { $_settings(-view3d) } {
-                set _settings(-saveopacity) $_settings($what)
-                set val [expr $_settings($what) * 0.01]
-                SendCmd "image opacity $val"
-            } else {
-                SendCmd "image opacity 1.0"
-            }
-        }
-        "-outline" {
-            set bool $_settings($what)
-            SendCmd "outline visible $bool"
-        }
-        "-stretchtofit" {
-            set bool $_settings($what)
-            if { $bool } {
-                if { $_settings(-view3d) } {
-                    SendCmd "camera aspect native"
-                } else {
-                    SendCmd "camera aspect window"
-                }
-            } else {
-                SendCmd "camera aspect native"
-            }
         }
         "-xgrid" - "-ygrid" - "-zgrid" {
@@ -1798,6 +1761,6 @@
     checkbutton $inner.visible \
         -text "Axes" \
-        -variable [itcl::scope _settings(-axisvisible)] \
-        -command [itcl::code $this AdjustSetting -axisvisible] \
+        -variable [itcl::scope _settings(-axesvisible)] \
+        -command [itcl::code $this AdjustSetting -axesvisible] \
         -font "Arial 9"
     checkbutton $inner.labels \
@@ -1830,5 +1793,5 @@
     label $inner.mode_l -text "Mode" -font "Arial 9"
 
-    itk_component add axisflymode {
+    itk_component add axismode {
         Rappture::Combobox $inner.mode -width 10 -editable 0
     }
@@ -1838,6 +1801,6 @@
         "furthest_triad"  "farthest" \
         "outer_edges"     "outer"
-    $itk_component(axisflymode) value $_settings(-axisflymode)
-    bind $inner.mode <<Value>> [itcl::code $this AdjustSetting -axisflymode]
+    $itk_component(axismode) value $_settings(-axismode)
+    bind $inner.mode <<Value>> [itcl::code $this AdjustSetting -axismode]
 
     blt::table $inner \
@@ -1976,10 +1939,10 @@
     radiobutton $inner.vtk_button -text "VTK data file" \
         -variable [itcl::scope _downloadPopup(format)] \
-        -font "Arial 9 " \
+        -font "Arial 9" \
         -value vtk
     Rappture::Tooltip::for $inner.vtk_button "Save as VTK data file."
     radiobutton $inner.image_button -text "Image File" \
         -variable [itcl::scope _downloadPopup(format)] \
-        -font "Arial 9 " \
+        -font "Arial 9" \
         -value image
     Rappture::Tooltip::for $inner.image_button \
@@ -2049,5 +2012,5 @@
     if { [info exists style(-stretchtofit)] } {
         set _settings(-stretchtofit) $style(-stretchtofit)
-        AdjustSetting -stretchToFit
+        AdjustSetting -stretchtofit
     }
     SendCmd "outline add $tag"
@@ -2095,5 +2058,5 @@
 # DrawLegend --
 #
-#       Draws the legend in the own canvas on the right side of the plot area.
+# Draws the legend in its own canvas on the right side of the plot area.
 #
 itcl::body Rappture::VtkImageViewer::DrawLegend {} {
@@ -2156,7 +2119,7 @@
     set x1 [expr $x2 - ($iw*12)/10]
 
-    $c bind title <ButtonPress> [itcl::code $this Combo post]
-    $c bind title <Enter> [itcl::code $this Combo activate]
-    $c bind title <Leave> [itcl::code $this Combo deactivate]
+    $c bind title <ButtonPress> [itcl::code $this LegendTitleAction post]
+    $c bind title <Enter> [itcl::code $this LegendTitleAction enter]
+    $c bind title <Leave> [itcl::code $this LegendTitleAction leave]
     # Reset the item coordinates according the current size of the plot.
     if { [info exists _limits($_curFldName)] } {
@@ -2272,15 +2235,17 @@
 
 # ----------------------------------------------------------------------
-# USAGE: _dropdown post
-# USAGE: _dropdown unpost
-# USAGE: _dropdown select
-#
-# Used internally to handle the dropdown list for this combobox.  The
-# post/unpost options are invoked when the list is posted or unposted
-# to manage the relief of the controlling button.  The select option
-# is invoked whenever there is a selection from the list, to assign
-# the value back to the gauge.
-# ----------------------------------------------------------------------
-itcl::body Rappture::VtkImageViewer::Combo {option} {
+# USAGE: LegendTitleAction post
+# USAGE: LegendTitleAction enter
+# USAGE: LegendTitleAction leave
+# USAGE: LegendTitleAction save
+#
+# Used internally to handle the dropdown list for the fields menu combobox.
+# The post option is invoked when the field title is pressed to launch the
+# dropdown.  The enter option is invoked when the user mouses over the field
+# title. The leave option is invoked when the user moves the mouse away
+# from the field title.  The save option is invoked whenever there is a
+# selection from the list, to alert the visualization server.
+# ----------------------------------------------------------------------
+itcl::body Rappture::VtkImageViewer::LegendTitleAction {option} {
     set c $itk_component(view)
     switch -- $option {
@@ -2292,16 +2257,16 @@
             tk_popup $itk_component(fieldmenu) $x $y
         }
-        activate {
+        enter {
             $c itemconfigure title -fill red
         }
-        deactivate {
+        leave {
             $c itemconfigure title -fill $itk_option(-plotforeground)
         }
-        invoke {
+        save {
             $itk_component(field) value $_curFldLabel
             AdjustSetting -field
         }
         default {
-            error "bad option \"$option\": should be post, unpost, select"
+            error "bad option \"$option\": should be post, enter, leave or save"
         }
     }
@@ -2328,2 +2293,33 @@
     set _view(-zoom) 1.0
 }
+
+itcl::body Rappture::VtkImageViewer::SetCurrentFieldName { dataobj } {
+    set _first $dataobj
+    $itk_component(field) choices delete 0 end
+    $itk_component(fieldmenu) delete 0 end
+    array unset _fields
+    set _curFldName ""
+    foreach cname [$_first components] {
+        foreach fname [$_first fieldnames $cname] {
+            if { [info exists _fields($fname)] } {
+                continue
+            }
+            foreach { label units components } \
+                [$_first fieldinfo $fname] break
+            $itk_component(field) choices insert end "$fname" "$label"
+            $itk_component(fieldmenu) add radiobutton -label "$label" \
+                -value $label -variable [itcl::scope _curFldLabel] \
+                -selectcolor red \
+                -activebackground $itk_option(-plotbackground) \
+                -activeforeground $itk_option(-plotforeground) \
+                -font "Arial 8" \
+                -command [itcl::code $this LegendTitleAction save]
+            set _fields($fname) [list $label $units $components]
+            if { $_curFldName == "" } {
+                set _curFldName $fname
+                set _curFldLabel $label
+            }
+        }
+    }
+    $itk_component(field) value $_curFldLabel
+}
Index: /branches/multichoice/gui/scripts/vtkisosurfaceviewer.tcl
===================================================================
--- /branches/multichoice/gui/scripts/vtkisosurfaceviewer.tcl	(revision 6370)
+++ /branches/multichoice/gui/scripts/vtkisosurfaceviewer.tcl	(revision 6371)
@@ -107,5 +107,5 @@
     private method ReceiveDataset { args }
     private method ReceiveImage { args }
-    private method ReceiveLegend { colormap title vmin vmax size }
+    private method ReceiveLegend { colormap title min max size }
     private method RequestLegend {}
     private method Rotate {option x y}
@@ -160,9 +160,8 @@
     private variable _rotatePending 0
     private variable _cutplanePending 0
-    private variable _field      ""
-    private variable _colorMode "scalar"; # Mode of colormap (vmag or scalar)
     private variable _fields
     private variable _curFldName ""
     private variable _curFldLabel ""
+    private variable _colorMode "scalar"; # Mode of colormap (vmag or scalar)
     private variable _mouseOver "";     # what called LegendRangeAction:
                                         # vmin or vmax
@@ -618,7 +617,4 @@
     }
     array set params $settings
-    set params(-description) ""
-    set params(-param) ""
-    array set params $settings
 
     if {$params(-color) == "auto" || $params(-color) == "autoreset"} {
@@ -657,5 +653,4 @@
         set _dlist [lreplace $_dlist $pos $pos]
         array unset _obj2ovride $dataobj-*
-        array unset _settings $dataobj-*
         set changed 1
     }
@@ -718,5 +713,5 @@
             return $dlist
         }
-        -image {
+        "-image" {
             if {[llength $args] != 2} {
                 error "wrong # args: should be \"get -image view\""
@@ -732,5 +727,5 @@
         }
         default {
-            error "bad option \"$op\": should be -objects or -image"
+            error "bad option \"$op\": should be -objects, -visible or -image"
         }
     }
@@ -1350,8 +1345,4 @@
 itcl::body Rappture::VtkIsosurfaceViewer::InitSettings { args } {
     foreach spec $args {
-        if { [info exists _settings($_first${spec})] } {
-            # Reset global setting with dataobj specific setting
-            set _settings($spec) $_settings($_first${spec})
-        }
         AdjustSetting $spec
     }
@@ -1505,5 +1496,5 @@
         }
         "-isolinecolor" {
-            set color [$itk_component(isolineColor) value]
+            set color [$itk_component(isolinecolor) value]
             set _settings($what) $color
             DrawLegend
@@ -1741,5 +1732,5 @@
 
     label $inner.linecolor_l -text "Isolines" -font "Arial 9"
-    itk_component add isolineColor {
+    itk_component add isolinecolor {
         Rappture::Combobox $inner.linecolor -width 10 -editable 0
     }
@@ -1756,5 +1747,5 @@
         "none"               "none"
 
-    $itk_component(isolineColor) value "white"
+    $itk_component(isolinecolor) value $_settings(-isolinecolor)
     bind $inner.linecolor <<Value>> \
         [itcl::code $this AdjustSetting -isolinecolor]
@@ -2184,5 +2175,5 @@
                     SendCmd "camera zoom $_view($what)"
                 }
-             }
+            }
         }
     }
@@ -2218,10 +2209,10 @@
     radiobutton $inner.vtk_button -text "VTK data file" \
         -variable [itcl::scope _downloadPopup(format)] \
-        -font "Arial 9 " \
+        -font "Arial 9" \
         -value vtk
     Rappture::Tooltip::for $inner.vtk_button "Save as VTK data file."
     radiobutton $inner.image_button -text "Image File" \
         -variable [itcl::scope _downloadPopup(format)] \
-        -font "Arial 9 " \
+        -font "Arial 9" \
         -value image
     Rappture::Tooltip::for $inner.image_button \
@@ -2259,4 +2250,5 @@
     array set style {
         -color                  BCGYR
+        -constcolor             white
         -cutplaneedges          0
         -cutplanelighting       1
@@ -2284,4 +2276,5 @@
         set style(-opacity) 1.0
     }
+    set style(-constcolor) $itk_option(-plotforeground)
     array set style [$dataobj style $comp]
     #DebugTrace [array get style]
@@ -2315,5 +2308,4 @@
     }
     if { $_currentColormap == "" } {
-        SetCurrentColormap $style(-color)
         $itk_component(colormap) value $style(-color)
     }
@@ -2343,5 +2335,5 @@
 
     SendCmd "cutplane add $tag"
-    SendCmd "cutplane color [Color2RGB $itk_option(-plotforeground)] $tag"
+    SendCmd "cutplane color [Color2RGB $style(-constcolor)] $tag"
     foreach axis {x y z} {
         set pos [expr $style(-${axis}cutplaneposition) * 0.01]
@@ -2359,5 +2351,5 @@
 
     SendCmd "outline add $tag"
-    SendCmd "outline color [Color2RGB $itk_option(-plotforeground)] $tag"
+    SendCmd "outline color [Color2RGB $style(-constcolor)] $tag"
     SendCmd "outline visible $style(-outline) $tag"
 
@@ -2367,5 +2359,5 @@
     SendCmd "contour3d edges $style(-edges) $tag"
     set _settings(-isosurfaceedges) $style(-edges)
-    #SendCmd "contour3d color [Color2RGB $style(-color)] $tag"
+    #SendCmd "contour3d color [Color2RGB $style(-constcolor)] $tag"
     SendCmd "contour3d lighting $style(-lighting) $tag"
     set _settings(-isosurfacelighting) $style(-lighting)
Index: /branches/multichoice/gui/scripts/vtkmeshviewer.tcl
===================================================================
--- /branches/multichoice/gui/scripts/vtkmeshviewer.tcl	(revision 6370)
+++ /branches/multichoice/gui/scripts/vtkmeshviewer.tcl	(revision 6371)
@@ -411,7 +411,4 @@
     }
     array set params $settings
-    set params(-description) ""
-    set params(-param) ""
-    array set params $settings
 
     if {$params(-color) == "auto" || $params(-color) == "autoreset"} {
@@ -510,5 +507,5 @@
             return $dlist
         }
-        -image {
+        "-image" {
             if {[llength $args] != 2} {
                 error "wrong # args: should be \"get -image view\""
@@ -524,5 +521,5 @@
         }
         default {
-            error "bad option \"$op\": should be -objects or -image"
+            error "bad option \"$op\": should be -objects, -visible or -image"
         }
     }
@@ -1467,5 +1464,5 @@
     radiobutton $inner.vtk_button -text "VTK data file" \
         -variable [itcl::scope _downloadPopup(format)] \
-        -font "Helvetica 9 " \
+        -font "Arial 9" \
         -value vtk
     Rappture::Tooltip::for $inner.vtk_button "Save as VTK data file."
